<?php
// download.php
//
// usage:
// php download.php CH1
// php download.php CH1 10000
//

require_once('lib/lib.exorpc.php');
require_once('lib/my.tools.php');


//
// 解析參數，生成 $tasks
//
$datapoint=$argv[1];
$count=5; // 預設讀取筆數
if(isset($argv[2]) && is_numeric($argv[2]))
  $count=intval($argv[2]);

$setting=array('limit'=>$count);
$task1=new exoTask('read', $datapoint, $setting);
$tasks=array($task1);

//執行 tasks
$response=exoRPC::perform($tasks);

//處理 返回資訊
$time_series=array();

if(isset($response['error'])){
  msg_log('download_err', json_encode($response['error']));
}
else{
  foreach($response as $res){
    $id=str_replace('read', '', $res['id']);
    if($res['status']=='ok'){
      $time_series[$id]=$res['result'];
    }
    else{
      $time_series[$id]=array();
      msg_log('download_err', json_encode($res));
    }
  }
}
//echo json_encode($time_series)."<br>\n";
$data=$time_series[$datapoint];
$filename=$datapoint.'-'.date('Ymd-His').".csv";
$fh = fopen($filename, 'w+');
foreach($data as $line){
  fputcsv($fh, $line);
}
fclose($fh);
//
//
echo $filename;
?>
