<?php
require_once('lib.exorpc.php');
require_once('my.tools.php');
abstract class Pusher{
  private $name, $log_ok, $log_err, $run;
  abstract function get_new_data();

  function __construct($name){
    $this->name= $name;           // ex. pusher1
    $this->log_ok =$name.'_log';  // ex. pusher1_log
    $this->log_err=$name.'_err';  // ex. pusher1_err
    $this->run='__'.$name.'__';   // ex. __pusher1__
  }

  function run($interval=3){
    if(file_exists($this->run)){
      echo "$this->name is already running!<br>\n";
      return;
    }
    else{
      file_put_contents($this->run,'run');
      echo "$this->name is running in background ...<br>\n";
      while(file_exists($this->run)){
        $tasks=array();
        $datalist=$this->get_new_data();
        foreach($datalist as $datapoint=>$value){
          array_push($tasks, new exoTask('write', $datapoint, $value));
        }
        // 執行 tasks
        $response = exoRPC::perform($tasks);

        // 處理 返回資訊
        if(isset($response['error'])){
          msg_log($this->log_err,json_encode($response['error']));
        }
        else{
          foreach($response as $res){
            if($res['status']!='ok')
              msg_log($this->log_err, json_encode($res));
            else{
              //msg_log($this->log_ok, $res['result']);
              echo $res['result']."\n";
            }
          }
        }
        sleep($interval);
      }
      echo "$this->name stopped safely!<br>\n";
    }
  }
}
?>
