<?php
// read.php
//
// usage:
// php read.php         讀取最近   5筆記錄
// php read.php 100     讀取最近 100筆記錄
//

require_once('lib/lib.exorpc.php');
require_once('lib/my.tools.php');

//
// 解析參數，生成 $tasks
//

$count=5; // 預設讀取筆數
if(isset($argv[1]) && is_numeric($argv[1]))
  $count=intval($argv[1]);

$setting=array(
  'limit'=>$count,
  'starttime'=>time()-60*6,
);
$task1=new exoTask('read', 'CH1', $setting);
$task2=new exoTask('read', 'CH2', $setting);
$tasks=array($task1, $task2);


//執行 tasks
$response=exoRPC::perform($tasks);

//處理 返回資訊
$time_series=array();

if(isset($response['error'])){
  msg_log('read_err', json_encode($response['error']));
}
else{
  foreach($response as $res){
    $id=str_replace('read', '', $res['id']);
    if($res['status']=='ok'){
      $time_series[$id]=$res['result'];
    }
    else{
      $time_series[$id]=array();
      msg_log('read_err', json_encode($res));
    }
  }
}
//
// 輸出 json
//
echo json_encode($time_series);

?>
