<?php
class exoRPC{
	const Header='Content-Type:application/json;charset=utf-8';
	const exoURL='http://m2.exosite.com/onep:v1/rpc/process';
	private $payload=['auth'=>"", 'calls'=>[]];
	private $debug;

	function __construct($cik, $debug=False){
		$this->debug=$debug;
		$this->payload['auth']=["cik"=>$cik];
	}
	function write($alias, $value){
		$task=[
			'id'=>56,
			'procedure'=>'write',
			'arguments'=>[
				['alias'=>$alias], 
				$value
			]
		];
		$this->payload['calls']=[$task];
		return $this->_exec_curl();

	}
	function read($alias, $limit){
		return $this->_read($alias, ["limit"=>$limit]);
	}

	private function _read($alias, $condition){
		$task=[
			'id'=>56,
			'procedure'=>'read',
			'arguments'=>[
				['alias'=>$alias], 
				$condition
			]
		];
		$this->payload['calls']=[$task];
		return $this->_exec_curl();
	}

	private function _exec_curl(){
		$json = json_encode($this->payload);
		if($this->debug) echo $json."\n\n";
		$ch = curl_init(self::exoURL);
		curl_setopt($ch, CURLOPT_POST, true);
		curl_setopt($ch, CURLOPT_HTTPHEADER,[self::Header]);
		curl_setopt($ch, CURLOPT_POSTFIELDS, $json);
		curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
		$result = curl_exec($ch);
		curl_close($ch);
		return $result;
	}
}

?>
